SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

# Выборка всех студентов, с повторяющимися именами
SELECT distinct st1.*, acc1.LastName
FROM students as st1
JOIN accounts as acc1 ON acc1.id = st1.AccountID
WHERE (
    SELECT count(*) from students as st2
	JOIN accounts as acc2 ON acc2.id = st2.AccountID
    where CONCAT( acc2.LastName, acc2.FirstName, acc2.SecondName )
        LIKE CONCAT( acc1.LastName, acc1.FirstName, acc1.SecondName)
    ) > 1
ORDER BY LastName


# выборка всех оценок для студента (с учетом повторений)
SELECT students.ID AS  "StudentID", accounts.LastName, rating_table . *
FROM students
JOIN accounts ON accounts.ID = students.AccountID
LEFT JOIN rating_table ON rating_table.StudentID = students.ID
WHERE CONCAT( accounts.LastName, accounts.FirstName, accounts.SecondName ) LIKE (
        SELECT CONCAT( acc.LastName, acc.FirstName, acc.SecondName )
        FROM students AS st
        JOIN accounts as acc ON acc.ID = st.AccountID
        WHERE st.id =133
    )
ORDER BY SubmoduleID



# студенты, повторно привязанные к дисциплинам
SELECT students.ID as "StudentID",
        accounts.LastName,
        disciplines_students.ID as "disciplines_studentsID"
FROM students
JOIN accounts ON accounts.ID = students.AccountID
left join disciplines_students on disciplines_students.StudentID = students.ID
WHERE CONCAT( accounts.LastName, accounts.FirstName, accounts.SecondName ) LIKE (
        SELECT CONCAT( acc.LastName, acc.FirstName, acc.SecondName )
        FROM students AS st
        JOIN accounts as acc ON acc.ID = st.AccountID
        where st.id = 133
    )


# дублирование оценок
SELECT distinct st1.*, rating_table.SubmoduleID, count(*) as "cnt"
FROM students as st1
JOIN accounts ON accounts.ID = st1.AccountID
LEFT JOIN rating_table on rating_table.StudentID = st1.ID
WHERE CONCAT( accounts.LastName, accounts.FirstName, accounts.SecondName ) LIKE (
        SELECT CONCAT( acc.LastName, acc.FirstName, acc.SecondName )
        FROM students AS st
        JOIN accounts as acc ON acc.ID = st.AccountID
        WHERE st.id = 133
    )
GROUP BY accounts.LastName, rating_table.SubmoduleID
ORDER BY cnt desc

-- список дубликатов и кол-во их оценок
select  t1.name,
        t1.recentSt,
        t1.lastSt,
        t2.cnt as beforeCnt,
        t3.cnt as afterCnt,
        tac1.Login IS NOT NULL,
        tac2.Login IS NOT NULL
from (
    select min(students.id) as recentSt, min(students.AccountID) as recentAcc,
            max(students.id) as lastSt, max(students.AccountID) as lastAcc,
            CONCAT( accounts.LastName, ' ', accounts.FirstName, ' ', accounts.SecondName) as name
    from students
	JOIN accounts ON accounts.id = students.AccountID
    group by CONCAT( accounts.LastName, accounts.FirstName, accounts.SecondName)
    having count(*) > 1
) as t1
left join accounts as tac1 on tac1.id = t1.recentAcc
left join accounts as tac2 on tac2.id = t1.lastAcc
left join (
    select  count(rating_table.Rate) as cnt,
            CONCAT( accounts.LastName, ' ', accounts.FirstName, ' ', accounts.SecondName) as name
    from students
	JOIN accounts ON accounts.id = students.AccountID
    left join rating_table on students.id = rating_table.StudentID
    where rating_table.Rate IS NOT NULL
    group by CONCAT( accounts.LastName, accounts.FirstName, accounts.SecondName)
) as t2 on STRCMP(t2.name, t1.name) = 0
left join (
    select t4.name,
            count(*) as cnt
    from (
        select  count(rating_table.Rate) as cnt,
                CONCAT( accounts.LastName, ' ', accounts.FirstName, ' ', accounts.SecondName) as name
        from students
		JOIN accounts ON accounts.id = students.AccountID
        left join rating_table on students.id = rating_table.StudentID
        where rating_table.Rate IS NOT NULL
        group by CONCAT( accounts.LastName, accounts.FirstName, accounts.SecondName), rating_table.submoduleID
    ) as t4
    group by t4.name
) as t3 on STRCMP(t3.name, t1.name) = 0
order by t1.recentSt

